game = {}

function game.load()
	pf = love.graphics.newImage("playerfront.png")
	pr = love.graphics.newImage("playerright.png")
	pl = love.graphics.newImage("playerleft.png")
	pb = love.graphics.newImage("playerback.png")
	bg = love.graphics.newImage("backgray.png")
	c = love.graphics.newImage("coin.png")
	coinsound = love.audio.newSource("pickup_coin.ogg", "static")
	
	af = newAnimation(pf, 58, 58, .2, 0)
	ar = newAnimation(pr, 58, 58, .2, 0)
	al = newAnimation(pl, 58, 58, .2, 0)
	ab = newAnimation(pb, 58, 58, .2, 0)
	
	pX = 371
	pY = 271
	
	direction = "forward"
	
	coins = {x, y}
	
	numcoins = 15
	
	while numcoins > 0 do
		x = math.random(742)
		y = math.random(542)
		table.insert(coins, {x = x, y = y})
		numcoins = numcoins - 1
	end
	
	score = 0
	
	timer = 0
end

function game.draw()
	love.graphics.draw(bg, bgX, bgY)
	love.graphics.print(score, 0, 0)
	love.graphics.print(timer, 20, 0)
	
	if direction == "forward" then
		af:draw(pX, pY)
	end
	if direction == "right" then
		ar:draw(pX, pY)
	end
	if direction == "left" then
		al:draw(pX, pY)
	end
	if direction == "back" then
		ab:draw(pX, pY)
	end
	for i, v in ipairs(coins) do
		love.graphics.draw(c, v.x, v.y)
	end
end

function game.update(dt)
	if love.keyboard.isDown("up") then
		pY = pY - 150*dt
		direction = "back"
		ab:update(dt)
	end
	if love.keyboard.isDown("right") then
		pX = pX + 150*dt
		direction = "right"
		ar:update(dt)
	end
	if love.keyboard.isDown("left") then
		pX = pX - 150*dt
		direction = "left"
		al:update(dt)
	end
	if love.keyboard.isDown("down") then
		pY = pY + 150*dt 
		direction = "forward"
		af:update(dt)
	end
	for i, v in ipairs(coins) do
		if(love.distance(v.x + 16, v.y + 16, pX + 29, pY + 29)) < 35 then
			table.remove(coins, i)
			score = score + 1
			love.audio.play(coinsound)
		end
	end
	timer = timer + dt
	
	if score == 15 then
		state = "gameover"
		gameover.load()
	end
end

function love.distance(x1, y1, x2, y2)
	distance = math.sqrt((x2-x1)^2 + (y2-y1)^2)
		return distance
	end
